<template>
    <div class="container">
        <div class="row">
            <div class="col-xs-12 col-sm-8 col-sm-offset-2 col-md-6 col-md-offset-3">
                <h1>Default/ Built-in Directives</h1>
                <p v-text="'Something else....'"></p>
                <p v-html="'<h1>This is heading one</h1>'"></p>
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12 col-sm-8 col-sm-offset-2 col-md-6 col-md-offset-3">
                <h1>Custom Directives</h1>
                <p v-custom:background.delayed="'yellow'">Color style by directives global</p>
                <p v-local-custom:background.delayed="{mainColor: 'red', sencondColor:'green', delay:500}">Color style by directives global</p>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        components: {

        },
        directives: {
            "local-custom": {
                bind(el, binding, vnode) {
                    var delay = 0;
                    if (binding.modifiers['delayed']) {
                        delay = 3000;
                    }
                    if (binding.modifiers["blink"]) {
                        let mainColor = binding.value.mainColor; //yellow
                        let secondColor = binding.value.secondColor;
                        let currentColor = mainColor;
                        
                        setTimeout(() => {
                            setInterval( ()=>{
                                currentColor == secondColor 
                                ? (currentColor = mainColor) 
                                : (currentColor = secondColor);
                                if (binding.arg == "background") {
                                el.style.backgroundColor = mainColor;   
                            } else {
                                el.style.color = mainColor;
                            }
                            }, binding.value.delay);
                        }, delay);
                    } else {
                        setTimeout(() => {
                            if (binding.arg == 'background') {
                                el.style.backgroundColor = binding.value;   
                            } else {
                                el.style.color = binding.value;
                            }
                        }, delay);
                    }

                } 
            }
        }
    }
</script>

<style>
    
</style>
